package com.pfc.Actividades;

import java.util.ArrayList;
import java.util.List;
import android.content.Intent;
import android.location.Location;
import android.net.Uri;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;

import com.pfc.Actividades.R;
import com.pfc.Actividades.RealidadAumentada.VistaAR;
import com.pfc.Actividades.Rutas.ServicioLocalizacion;
import com.google.android.maps.GeoPoint;
import com.google.android.maps.MapActivity;
import com.google.android.maps.MapController;
import com.google.android.maps.MapView;
import com.google.android.maps.Overlay;
import com.pfc.Info.GeoNodo;
import com.pfc.InfoCapas.CapaGenerica;
import com.pfc.Superposicion.SuperposicionMapa;

// Esta actividad muestra (una vez elegido un nodo, ej: puente triana) el mapa con el nodo
// localizado, y da paso al menu donde puede seleccionar verlo en AR

public class InfoNodo extends MapActivity  {

	private static final int MENU_AR = Menu.FIRST + 1;

	private MapView mapView;
	private int iconId;

	protected GeoNodo mNode;
	
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);

		Intent i = getIntent();
		
		if(i.hasExtra("node"))
			mNode = (GeoNodo) i.getSerializableExtra("node");
		
	}
	
	@Override
	protected boolean isRouteDisplayed() {
		// TODO Auto-generated method stub
		return false;
	}
	
	protected void setIconId(int id){
		iconId = id;
	}
	
	protected void showMap(Double longitude, Double latitude)
    {
        mapView = (MapView) findViewById(R.id.myMapView);
    	 
        MapController mapControl = mapView.getController();
        
        GeoPoint geoPoint = new GeoPoint(  (int) (mNode.getLatitude() * 1000000), 
        						  		   (int) (mNode.getLongitude() * 1000000));
        mapControl.setZoom(17);
        mapControl.setCenter(geoPoint);
        
	    //Config overlay
	    SuperposicionMapa myMapOver = new SuperposicionMapa();
	    myMapOver.setDrawable(getResources().getDrawable(iconId));
	    
	    myMapOver.setGeoPoint(geoPoint);
	   
        final List<Overlay> overlays = mapView.getOverlays();
        overlays.add(myMapOver);
	    
	    mapView.setClickable(true); 
    }
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
        super.onCreateOptionsMenu(menu);
        menu.add(0, MENU_AR, 0, "Mostrar en Realidad Aumentada")
        		.setIcon(R.drawable.real_view)
                .setAlphabeticShortcut('A');
        return true;
    }
	
    @Override
    public boolean onOptionsItemSelected (MenuItem item) {
    	switch (item.getItemId()) {
    	
    		case MENU_AR:
    			ArrayList<GeoNodo> list = new ArrayList<GeoNodo>();
    			list.add(mNode);
    			CapaGenerica mylayer =  new CapaGenerica(-1, "", "Single node", "", "",
    					0.0, 0.0, 0.0, 0.0, ""  );
    			mylayer.setNodes(list);
    			
    			Intent i = new Intent(this, VistaAR.class);

    			GestorDato.getInstance().putData(GestorDato.GENERIC_LAYER, mylayer);
    			GestorDato.getInstance().putData(GestorDato.LAYER_CATEGORIES, mylayer.getCategories("id"));

                startActivity(i);
    			break; 			
    	}
    	return super.onOptionsItemSelected(item);
    }
}