package com.pfc.Actividades;

import java.util.ArrayList;
import android.app.ListActivity;
import android.app.ProgressDialog;
import android.content.DialogInterface;
import android.gesture.GestureLibrary;
import android.os.Bundle;
import android.os.Handler;
import android.os.Message;
import android.util.Log;
import android.view.ContextMenu;
import android.view.MenuItem;
import android.view.View;
import android.view.ContextMenu.ContextMenuInfo;

import com.pfc.Actividades.R;
import com.pfc.Info.GeoNodo;

//  esta actividad es utilizada justo cdo le damos a panoramio, para mostrar la lista 
// generica de nodos.

/**
 * This class implements a generic list to show the nodes of social network.
 * All the generic features are implemented in this class. 
 */

public class ListaGenerica extends ListActivity {
		
	/** List of nodes that are shown.  */
	protected static ArrayList<GeoNodo> mNodeList;
	
	/** ProgressDialog */
	private ProgressDialog mPDialog;
	
	private GestureLibrary mLibrary;
	
	//GeoNodo where is save the node alarm
	protected GeoNodo mNode;
	
	public void onCreate(Bundle savedInstanceState) {
		// Init
		super.onCreate(savedInstanceState);
		setContentView(R.layout.gesture_view);		 	
		registerForContextMenu(this.getListView());
	}
	
	
	public void setList (ArrayList<GeoNodo> list)
	{
		mNodeList = list;
	}
			
	
	@Override
	public boolean onContextItemSelected(MenuItem item) 
	{
		return true;
	}
	
	
	/** This method show the progressDialog while a list of nodes is loaded 
	 * 
	 *  @param title Title to progressDialog
	 *  @param description Description to progressDialog
	 *  @param th this thread is executed while progressDialog is shown.
	 * */
	protected void executePetition (String title, String description, final Thread th)
	{		    	
    	DialogInterface.OnCancelListener dialogCancel = new DialogInterface.OnCancelListener() {

            public void onCancel(DialogInterface dialog) {	
            	th.stop();
            }
        };
        mPDialog = ProgressDialog.show(this, title, description, true, true, dialogCancel);			
        th.start();
	}
	
	
	protected Handler handler_PDialog = new Handler() {
		@Override
		public void handleMessage(Message msg) {	
			try{
				mPDialog.dismiss();	
			}catch(Exception e){
				Log.e("ListaGenerica", "", e);
			}
		}
	};
	

	public void run() {
		handler_PDialog.sendEmptyMessage(0);
	}
}