package com.pfc.Actividades.RealidadAumentada;

import android.app.Activity;
import android.content.Intent;
import android.location.Location;
import android.util.Log;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.ViewGroup.LayoutParams;
import android.widget.Toast;

import com.pfc.InfoCapas.CapaGenerica;
import com.pfc.Utilidades.Localizacion;

// Esta clase es utilizada cdo se muestra AR en la camara

public class ARTagManager{

	public static final int TAG_IMMEDIATE = 0;
	public static final int TAG_FAST = 1;
	public static final int TAG_MAP = 2;
	public static final int TAG_ACCURATE_SIDE = 3;
	public static final int TAG_ACCURATE_LINE = 4;
	public static final int TAG_ANGLE = 5;
	
	private int savingType;
	private float[] user_location = new float[3];
	private float[] user_location_fixed = new float[3];
	private float cam_altitude_inst;
	private float cam_altitude;

	private float[] resource_location = new float[3];
    private float[] angles = new float[3];
    private float[] res_angles = new float[3];
    private double distance = 0;
	
	private Activity mActivity;
	private GestorCapa layers;
	private CapaGenerica myLayer;
	
	OnClickListener fast_click = new OnClickListener() {
		
		public void onClick(View v) {
			layers.removeExtraElement((View) v.getParent());
		}
	};
	
	OnClickListener ok_click = new OnClickListener() {
		public void onClick(View v) {
			Log.e("EEEEEEEEE5","EEEEEEEEE5");
	//		tagAction();
		}
	};
	
	public ARTagManager(Activity mActivity, GestorCapa layers, CapaGenerica myLayer){
		this.mActivity = mActivity;
		this.layers = layers;
		this.myLayer = myLayer;
	}
	
	public void setSavingType(int savingType){
		this.savingType = savingType;
		switch(savingType){
		case TAG_IMMEDIATE:
		//	tagAction();
			return;
			
		case TAG_MAP:
			break;
		}
	}
	
	public void setUserLocation(float[] user_location){
		this.user_location = user_location.clone();
	}
	
	public void setResourceLocation(float[] resource_location){
		this.resource_location = resource_location.clone();
	}
	
	public void setAngles(float[] angles){
		this.angles = angles.clone();
	}
	
	public void setCamAltitude(float cam_altitude_inst){
		this.cam_altitude_inst = cam_altitude_inst;
	}
	
	public int getSavingType(){
		return savingType;
	}
	
	public float[] getResourceLocation(){
		return resource_location;
	}
	
	public float[] getUserLocation(){
		return user_location;
	}
	
	public float[] getAngles(){
		return angles;
	}
	
    public Location resourceCoords(int savingType){
    	Location resource =  new Location("TAG");
    	float[] res_location;
    	float res_distance, res_height;	
    	
    	switch(savingType){
    	
    	case TAG_IMMEDIATE:
    		res_location = user_location_fixed;
    		break;
    	
    	case TAG_FAST:
    		res_location = Localizacion.calculateIntersection(user_location_fixed, GestorBrujula.getAzimuth(res_angles), (float)distance);
    		break;
    		
    	case TAG_MAP:
    		res_location = resource_location;
    		break;
    		
    	default:
    		res_location = new float[2];	
    		
    	}
    	
    	if(res_location==null)
    		return null;
    	
    	res_distance = Localizacion.calculateDistance(user_location_fixed, res_location);
    	res_height = Localizacion.calculateResourceHeight(GestorBrujula.getElevation(res_angles), res_distance);
    	
    	resource.setLatitude(res_location[0]);
    	resource.setLongitude(res_location[1]);
    	resource.setAltitude(res_height);
    	
    	//FIXME Testing lines
    	
    	return resource;
    }
}