package com.pfc.Actividades;

import java.io.File;
import java.io.FileOutputStream;
import android.app.Activity;
import android.content.Intent;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Bundle;
import android.view.Menu;
import android.view.MenuItem;
import android.widget.ImageView;
import android.widget.TextView;

import com.pfc.Actividades.R;
import com.pfc.Info.LibreGeoSocial;

public class VerFoto extends Activity{

	private static final int MENU_SHARE = Menu.FIRST + 1;
	
	private ImageView imageUser;
	private TextView lbTitle;
	private String url, name, data;
	private Bitmap photo;
	
	public void onCreate(Bundle icicle) {
		super.onCreate(icicle);
		setContentView(R.layout.view_photo);
		
        Intent i = getIntent();
		
        lbTitle = (TextView) this.findViewById(R.id.lbTitle);
        imageUser = (ImageView) this.findViewById(R.id.lbImage);       
		url = i.getStringExtra("url");
		name = i.getStringExtra("name");
		data = i.getStringExtra("data");
        photo = LibreGeoSocial.getInstance().getBitmap(url+"medium/");                  
        imageUser.setImageBitmap(photo);       
        lbTitle.setText (name);
	}
	
	@Override
    public boolean onCreateOptionsMenu(Menu menu) {
    	
        super.onCreateOptionsMenu(menu);                		        
        return true;
    }
	
    @Override
    public boolean onOptionsItemSelected (MenuItem item) {
    	
    	switch (item.getItemId()) {
    	
    		case MENU_SHARE:

    			String tmp_path = getResources().getString(R.string.tmp_path);

                //create the dir if not exists
                File dirhandler = new File (tmp_path);
                if(! dirhandler.exists())
                  dirhandler.mkdirs();

                try {
                    FileOutputStream out = new FileOutputStream( tmp_path + name.replace(" ", "_") + ".jpeg");
                            photo.compress(Bitmap.CompressFormat.JPEG, 100, out);
                            out.flush();
                            out.close();
                    } catch (Exception e) {
                            e.printStackTrace();
                    }

                Intent i = new Intent(Intent.ACTION_SEND);
                i.setFlags(Intent.FLAG_ACTIVITY_NEW_TASK);
                i.putExtra(Intent.EXTRA_TEXT, data);
                i.setType("image/jpeg");
                i.putExtra(Intent.EXTRA_SUBJECT, "[LGS-Foto] " + name);
                i.putExtra(Intent.EXTRA_STREAM, Uri.fromFile(new File( tmp_path + name.replace(" ", "_") + ".jpeg")));
                startActivity(i);
       	}
    	return super.onOptionsItemSelected(item);
    }
}