package com.pfc.Info;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.net.URL;
import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.cert.CertificateException;
import java.security.cert.X509Certificate;
import java.util.ArrayList;
import java.util.List;

import javax.net.ssl.HostnameVerifier;
import javax.net.ssl.HttpsURLConnection;
import javax.net.ssl.SSLSession;
import javax.net.ssl.TrustManager;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.NameValuePair;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.message.BasicNameValuePair;
import org.apache.http.protocol.HTTP;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.location.Location;
import android.util.Log;

import com.pfc.Actividades.LocalizadorAR;
import com.pfc.Actividades.Home;
import com.pfc.Actividades.Rutas.ServicioLocalizacion;
import com.pfc.InfoCapas.Categoria;
import com.pfc.InfoCapas.CapaGenerica;
import com.pfc.Utilidades.MapaBit;
import com.pfc.Utilidades.ClientHttpRequest;


public class LibreGeoSocial {

	private static TrustManager[] trustManagers;
	
	/* TAG for log messages*/
	static private String TAG = "LibreGeoSocial";
	
	/* Singleton */
	static private LibreGeoSocial singleton = null;
	
	/* Format that server answer*/
	private String mFormat = "JSON";
	
	/* Url from server: Ex: test.libregeosocial.libresoft.es/social/ */
	private String mUrl = null;
	
	private String mUrlHttps = null;
	
	/* Message from last petition */
	private String lastMsg = null;
	
	/* Code from last petition */
	private Integer lastCode = 0;
	
	/* Id for last node uploaded */
	private Integer lastId = 0;
	
	private Usuario mUser = null;
	private boolean loged = false;
	
	/* Photos paginacion */
	private static Integer mpagePhoto = 1;
	
	/* Notes pagination */
	private static Integer mpageNote = 1;
	
	
	private ArrayList<GeoNodo> mUserList = null;
	
	private ArrayList<GeoNodo> mFriendList = null;
	
	public void resetUser(){
		mUser = null;
		loged = false;
	}
	
	static public LibreGeoSocial getInstance() 
	{
        if (singleton == null) {
            singleton = new LibreGeoSocial();
        }
        return singleton;
		
	}
	
	public boolean deleteNode (Integer nodeId, String LayerId)
	{
	
		try
		{
			DefaultHttpClient httpclient = new DefaultHttpClient();
			Log.e("DALE", mUrl + "layer/" + LayerId + "/node/" + nodeId + "/delete/?format=JSON");
			HttpGet httpGet = new HttpGet(mUrl + "layer/" + LayerId + "/node/" + nodeId + "/delete/?format=JSON"); 
			
			HttpResponse response = httpclient.execute(httpGet);
			HttpEntity entity = response.getEntity();
			String str = convertStreamToString(entity.getContent());
			Log.e(TAG, str);
			
			//maybe this crash!
			return processMessage(str);
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return false;
		}
		
	}
	
	public void setFormat (String format)
	{
		
		if ( format.compareTo("JSON") != 0 && format.compareTo("XML") != 0) 
		{
			Log.e("TAG", "Unknow format\n");
		}
		
		mFormat = format;
		
	}
	
	public String getUrlServer ()
	{
		return mUrl;
	}
	
	public void setUrl (String Url)
	{
		mUrl = "http://" + Url;
		mUrlHttps = "https://" + Url;
	}
	
	public String getLastMsgServer()
	{		
		return "[" + lastCode.toString() + "]: " + lastMsg;
	}
	
	public Integer getLastId ()
	{
		return lastId;
	}
	
	

	public Location getLocation(){
		
		Location myLocation = ServicioLocalizacion.getCurrentLocation();
		
		if ((myLocation == null) & (isLogged())){
			ServicioLocalizacion.setLastKnownLocation(mUser.getLocation());
			myLocation = mUser.getLocation();
		}
		
		return myLocation;
	}
	
	public ArrayList<GeoNodo> getLayerNodes (Integer id, String pattern, String category, Double distance, Integer page, Integer elems)
	{	
		try
		{
			
			DefaultHttpClient httpclient = new DefaultHttpClient();
			HttpPost httpost;
		

			if (pattern==null)
				pattern = "";
			
			if (getLocation() == null){
				Log.e("getLocation", "Not location returnet");
				return null;
			}
			
			httpost = new HttpPost(mUrl +  "layer/" + id.toString() + 
								   "/search/?search=" + pattern + 
								   "&category=" + category +
								   "&latitude=" + String.valueOf(getLocation().getLatitude()) + 
								   "&longitude=" + String.valueOf(getLocation().getLongitude()) + 
								   "&page=" + page.toString() +
								   "&elems=" + elems.toString() +
								   "&radius=" + distance.toString() + "&format=JSON");
							
			Log.e("LGS-getLayerNodes:", mUrl +  "layer/" + id.toString() + 
								   "/search/?search=" + pattern + 
								   "&category=" + category +
								   "&latitude=" + getLocation().getLatitude() + 
								   "&longitude=" + getLocation().getLongitude() + 
								   "&page=" + page.toString() +
								   "&elems=" + elems.toString() +
								   "&radius=" + distance.toString() + "&format=JSON");
						
			HttpResponse response = httpclient.execute(httpost);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());
	        
	        Log.e(TAG, str);
	        
	        ArrayList<GeoNodo> array = new ArrayList<GeoNodo>();
	        ArrayList<GeoNodo> aux = null;
	        
	        aux = parseNodes (str);
	        if (aux!=null)
	        	array.addAll (aux);
	        
	        Log.e("LGS: size array=",String.valueOf(array.size()));
	 
	        return array;
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}
		
	}
	
	

	
    /**
     * Return the GeoNodo updated
     * @param node The node we want updated
     * 
     * @return The GeoNodo
     */
	public GeoNodo updateNode (GeoNodo node)
	{
		try
		{			
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			Log.e("id", node.getId().toString());
			
			Integer nodeId = node.getId();
			
			if (nodeId == 0){
				return node;
			}
			
			Integer layerId = (Integer) getLayerId(nodeId).get(0);
			
			Log.e("URL", mUrl + "layer/" + layerId.toString() +"/node/"+ node.getId().toString() + "/data/?format=JSON");
			
			HttpGet httpGet = new HttpGet(mUrl + "layer/" + layerId.toString() +"/node/"+ node.getId().toString() + "/data/?format=JSON");						
			
			HttpResponse response = httpclient.execute(httpGet);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());
	        
	        Log.e(TAG, str);    
	        
	        ArrayList<GeoNodo> list = new ArrayList<GeoNodo>();
	        
	        list = parseNodes(str);
	        
	        if (list == null)
	        	return null;
	        
            return list.get(0);

		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}
		
	}

	
	
    /**
     * Return the info user
     * 
     * @param reaload If is false, data obtains of cache.
     * @param userId The identifier of user 
     * 
     * @return The user info
     */
	
	public Usuario getInfoUser (boolean reload, Integer userId)
	{
		if (isLogged()){
			if ( reload == false && mUser != null)
				return mUser;
		
			try
			{
				DefaultHttpClient httpclient = new DefaultHttpClient();
			
				HttpPost httpget = null;
			
				if (userId==null)
					httpget = new HttpPost(mUrl + "user/data/?format=JSON");
				else
					httpget = new HttpPost(mUrl + "user/" + userId.toString() + "/data/?format=JSON");
			
				HttpResponse response = httpclient.execute(httpget);
	
				HttpEntity entity = response.getEntity(); 
		    
				String str = convertStreamToString(entity.getContent());	        
	        
				Log.e(TAG, str);
	        
           
				ArrayList<GeoNodo> list = new ArrayList<GeoNodo>();
	        
				Log.e("ARRAY", str);
				list = parseNodes(str);
	        
				if (list != null){
					mUser = (Usuario) list.get(0);
					return mUser;
				}
	        
				//If list is null we return null
				return null;
        
			}
		
			catch (IOException e) {
				Log.e(TAG,e.getMessage());
				return null;
			}
		} else { 
			Log.e("InfoUser", "NULL");
			return null;
		}
		
	}
	
	
    /**
     * Set the status of user.
     * 
     * @param status Text of the status
     * 
     * @return Boolean
     */
	
	public boolean setStatus (String status)
	{
	
		try
		{
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			HttpPost httpost = new HttpPost(mUrl + "user/set_status/?format=JSON"); 
			
			List <NameValuePair> nvps = new ArrayList <NameValuePair>();
		    nvps.add(new BasicNameValuePair("status", status )); 
			
		    httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8)); 		    
			
			HttpResponse response = httpclient.execute(httpost);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());
	        
	        Log.e(TAG, str);
	        
            return processMessage(str);

		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return false;
		}
		
	}
	

	
	
    /**
     * Set an user geo-position 
     * 
     * @param latitude latitude coordenate
     * @param longitude longitude coordenate
     * 
     * @return Boolean variable
     */
	public boolean setUserPosition (Double latitude, Double longitude, Double altitude)
	{
		if (isLogged()){
			try
			{
				DefaultHttpClient httpclient = new DefaultHttpClient();
			
				HttpPost httpost = new HttpPost(mUrl + "user/position/?format=JSON"); 
			
				List <NameValuePair> nvps = new ArrayList <NameValuePair>();
				nvps.add(new BasicNameValuePair("latitude", latitude.toString()));
				nvps.add(new BasicNameValuePair("longitude", longitude.toString()));
				nvps.add(new BasicNameValuePair("altitude", altitude.toString()));
			
				httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8)); 
		    
				HttpResponse response = httpclient.execute(httpost);
	
				HttpEntity entity = response.getEntity(); 
		    
				String str = convertStreamToString(entity.getContent());	        
	        
				Log.e(TAG, str);
	        
				return processMessage(str);
	                
			}
		
			catch (IOException e) {
				Log.e(TAG,e.getMessage());
				return false;
			}
		} else {
			return false;
		}
		
	}
	
    /**
     * Create and upload note to server 
     * 
     * @param note It's a note objetc.     
     * 
     * @return Boolean variable
     */	

	public void setPageNote (Integer pageNote)
	{
		mpageNote = pageNote;
	}
	
    
	public boolean uploadPhoto (Foto photo, Integer layerId)
	{
		
		try
		{			
			ClientHttpRequest myclient = new ClientHttpRequest( mUrl + "layer/" + layerId.toString() +"/photo/upload/?format=JSON");
			
			InputStream serverInput = myclient.post (
														new Object[] {
															"latitude", photo.getLatitude().toString(),
										                    "longitude", photo.getLongitude().toString(),
										                    "altitude", photo.getAltitude().toString(),
										                    "name", photo.getName(),
										                    "description" , photo.getDescription(),
										                    "photo", new File(photo.getUrl()) 
														}
													 );                   
			
			BufferedReader in = new BufferedReader(new InputStreamReader(serverInput));
			
			String inputLine;			
			String reponseString = "";
			
			while ((inputLine = in.readLine()) != null) {
				Log.e(TAG,"EPPP:" + inputLine);
				reponseString = reponseString + inputLine;
			}
			

	        Log.e(TAG, reponseString);
	        
	        return processMessage(reponseString);

		}
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return false;
		}
		
	}
	
	
	public boolean setPrivacyNode (Integer nodeId, String privacyLevel, Boolean updateLocation)
	{
		Log.e("SetPrivacyNode","nodeId: " + nodeId.toString() + " privacy: " + privacyLevel);
		Log.e("SetPrivacyLocation: ", updateLocation.toString());
		
		try
		{
			DefaultHttpClient httpclient = new DefaultHttpClient();
			HttpPost httpost;
			
			httpost = new HttpPost(mUrl + "node/" + nodeId.toString() + "/privacy/change/?format=JSON"); 

			List <NameValuePair> nvps = new ArrayList <NameValuePair>();
			
			if (updateLocation)
				nvps.add(new BasicNameValuePair("field", "position"));
			
			nvps.add(new BasicNameValuePair("perm", privacyLevel));
			
		    httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));		    		    

			HttpResponse response = httpclient.execute(httpost);
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());
	        
	        Log.e(TAG, str);

	        return processMessage(str);
	        
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return false;
		}
		
		
	}
	
	public InputStream getStream (String url)
	{
		
		try
		{
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			HttpPost httpost = new HttpPost(mUrl + url);
			
			/* create cookie */
			if (isLogged()){
				List <NameValuePair> nvps = new ArrayList <NameValuePair>();			
				httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));		    		    
			}
			/* Send and receive the petition */
			HttpResponse response = httpclient.execute(httpost);
		    HttpEntity entity = response.getEntity(); 
		    
		    return entity.getContent();
		   	
		    
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}
	}
	
	
	public Bitmap getBitmap (String url)
	{
		final int IO_BUFFER_SIZE = 4 * 1024;
		
		try
		{
			DefaultHttpClient httpclient = new DefaultHttpClient();
	
			HttpPost httpost = new HttpPost(mUrl + url);
			
			Log.e("getBitMap:",mUrl + url);
			
			/* create cookie */
			if (isLogged()){
				List <NameValuePair> nvps = new ArrayList <NameValuePair>();			
				httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));	
			}
			/* Send and receive the petition */
			HttpResponse response = httpclient.execute(httpost);
		    HttpEntity entity = response.getEntity(); 
		    
		    InputStream in = entity.getContent();
		    
		    /* Convert response to bitmap */
            final ByteArrayOutputStream dataStream = new ByteArrayOutputStream();
            BufferedOutputStream out = new BufferedOutputStream(dataStream, IO_BUFFER_SIZE);
            MapaBit.copy(in, out);
            out.flush();
            
            final byte[] data = dataStream.toByteArray();
            Bitmap bitmap = BitmapFactory.decodeByteArray(data, 0, data.length);
	        
            return bitmap;
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}
	}
	
	public ArrayList<GeoNodo> getMyPhotos ()
	{
	
		try
		{
			DefaultHttpClient httpclient = new DefaultHttpClient();
			HttpPost httpost;
			
			httpost = new HttpPost(mUrl + "user/" + mUser.getId().toString() + "/photos/?format=JSON"); 

			List <NameValuePair> nvps = new ArrayList <NameValuePair>();
			
		    httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8));		    		    

			HttpResponse response = httpclient.execute(httpost);
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());
	        
	        Log.e(TAG, str);

	        return parseNodes(str);
	        
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}
		
	}
	
	public void setPagePhoto (Integer pagePhoto)
	{
		mpagePhoto = pagePhoto;
	}
		
    private String convertStreamToString (InputStream is) {
        BufferedReader reader = new BufferedReader(new InputStreamReader(is), 8*1024);
        StringBuilder sb = new StringBuilder();
 
        String line = null;
        try {
            while ((line = reader.readLine()) != null) {
                sb.append(line + "\n");
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                is.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        
        return sb.toString();

    }
	
	
    
    public static String PRIVACY_PUBLIC 			= "Public";
    public static String PRIVACY_PRIVATE			= "Private";
   
    
    public boolean setProfilePrivacy (String privacyLevel)
    {
    
		try
		{
			
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			HttpPost httpost = new HttpPost(mUrl + "user/privacy/change/?format=JSON"); 
			
			List <NameValuePair> nvps = new ArrayList <NameValuePair>();
		    nvps.add(new BasicNameValuePair("perm", privacyLevel));
			
		    httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8)); 
		    
			HttpResponse response = httpclient.execute(httpost);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());	        
	        
	        Log.e(TAG, str);
	        
	        return processMessage(str);
	                
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return false;
		}
    	
    }
    
    public boolean setLocationPrivacy (String privacyLevel)
    {
    
		try
		{
			
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			HttpPost httpost = new HttpPost(mUrl + "user/privacy/allow/?format=JSON"); 
			
			List <NameValuePair> nvps = new ArrayList <NameValuePair>();
		    nvps.add(new BasicNameValuePair("field", "position"));
		    nvps.add(new BasicNameValuePair("role", privacyLevel));
			
		    httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8)); 
		    
			HttpResponse response = httpclient.execute(httpost);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());	        
	        
	        Log.e(TAG, str);
	        
	        return processMessage(str);
	                
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return false;
		}
    	
    }
    
    public boolean setTags (Integer id, String tags)
    {
    	
		try
		{
			
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			HttpPost httpost = new HttpPost(mUrl + "node/" + id.toString() + "/tag/?format=JSON"); 
			
			List <NameValuePair> nvps = new ArrayList <NameValuePair>();
		    nvps.add(new BasicNameValuePair("tags", tags));
			
		    httpost.setEntity(new UrlEncodedFormEntity(nvps, HTTP.UTF_8)); 
		    
			HttpResponse response = httpclient.execute(httpost);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());	        
	        
	        Log.e(TAG, str);
	        
	        return processMessage(str);
	                
		}
		
		catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return false;
		}
    	
    }
  
    
	private boolean processMessage (String str)
	{
		
        try {
        	JSONObject json;
			json = new JSONObject(str);
			lastCode = json.getInt("code");
			lastMsg  = json.getString("description");
			
			if (json.has("id"))
				lastId = json.getInt("id");
			else
				lastId = -1;
			
			if (lastCode != 200)
				return false;
			
		} catch (JSONException e) {	
			lastCode = 500;
			lastMsg = "Error in json parsed: " + e.getMessage();
			Log.e(TAG, e.toString());
			return false;
		}
		
		return true;
		
	}
	
	public Boolean isLogged(){
		if (loged == false){
			return false;
		}
		else 
			return true;
	}
	
	public ArrayList<Categoria> parseCategories(Integer layerId){
		
		Integer id = null;
		String name = "";
		String description = "";
		
		ArrayList<Categoria> list = new ArrayList<Categoria>();
		
		try{
			DefaultHttpClient httpclient = new DefaultHttpClient();						
			HttpGet httpGet = new HttpGet(mUrl + "layer/" + layerId.toString() + "/categories/?format=JSON");	
			
			HttpResponse response = httpclient.execute(httpGet);
			HttpEntity entity = response.getEntity(); 
			String str = convertStreamToString(entity.getContent());
        
			JSONObject json;
			
			try{	
				json = new JSONObject(str);
				lastCode = json.getInt("code");
								
				if (lastCode != 200)
					return null;
				
				JSONArray array;
				array = json.getJSONArray("results");
				
				for (int i = 0; i < array.length(); i++) 
				{
					JSONObject obj = array.getJSONObject(i);
					
					if (array.length() == 1){
						id = 0;
						name = "No categories";
						description = "this layer has not categories";
						Categoria one_category = new Categoria(id, name, description);
						list.add(one_category);
						break;
					}
					if (obj.has("id")){
						id = obj.getInt("id");
						if (id == 0)
							continue;
					}
					if (obj.has("name"))
						name = obj.getString("name");
					if (obj.has("description"))
						description = obj.getString("description");
					
					Categoria category = new Categoria(id, name, description);
					list.add(category);
					
					
				}

			} catch (JSONException e) {	
				lastCode = 500;
				lastMsg = "Error in json parsed: " + e.getMessage();
				Log.e(TAG, e.toString());
				return null;
			}	
			
		
		} catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}		
		
		return list;
	}
	
	private ArrayList<GeoNodo>  parseNodes (String str)
	{
		 
        JSONObject json;
        
        ArrayList<GeoNodo> list = new ArrayList<GeoNodo>();
        
        try {
			json = new JSONObject(str);
			lastCode = json.getInt("code");
							
			if (lastCode != 200)
				return null;
			
			JSONArray array;
			
			array = json.getJSONArray("results");

			Log.e("parseNodes_new: ",String.valueOf(array.length()));
			Log.e("PARSE", array.toString());
			
			for (int i = 0; i < array.length(); i++) 
			{ 

				Log.e("PARSE", array.getJSONObject(i).toString());
				GeoNodo node = parseNode (array.getJSONObject(i));
							
				list.add(node);
				
			}
			
			return list;
			
		} catch (JSONException e) {	
			lastCode = 500;
			lastMsg = "Error in json parsed: " + e.getMessage();
			Log.e(TAG, e.toString());
			return null;
		}
	}
	
	private GeoNodo  parseNode (JSONObject obj)
	{
		String type = "";
		String since, position_since, username;
		Double latitude, longitude, altitude, radius, distance;
		Integer user_id = 0;
		Integer id = 0;
		latitude = longitude = altitude = radius = distance = -1.0;
		since = position_since = "";
		username = "";
		
		GeoNodo node = null;

		try
		{
			if (obj.has("type")){
				type = obj.getString("type");
			}else{
				Log.e("Parse node error: ", "no type in node");
				return null;
			}		

			if (obj.has("id"))
				id = obj.getInt("id");
			
			if (obj.has("since"))
				since = obj.getString("since");	
								
			if (obj.has("position"))
			{
				JSONObject jsonPosition = obj.getJSONObject("position");
				if (jsonPosition.has("latitude"))
					latitude = jsonPosition.getDouble("latitude");
				if (jsonPosition.has("longitude"))
					longitude = jsonPosition.getDouble("longitude");
				if (jsonPosition.has("altitude"))
					altitude = jsonPosition.getDouble("altitude");
				if (jsonPosition.has("since"))
					position_since = jsonPosition.getString("since");
				
				if (obj.has("radius"))
					radius = jsonPosition.getDouble("radius");									
			}
			
			if (obj.has("uploader"))
			{
				JSONObject jsonPosition = obj.getJSONObject("uploader");
				if (jsonPosition.has("username"))
					username = jsonPosition.getString("username");
				if (jsonPosition.has("id"))
					user_id = jsonPosition.getInt("id");
									
			}
			
			// parse for person type
			if (type.equalsIgnoreCase("person")){
				Usuario user = parseUser(obj);
				if (user == null){
					Log.e(TAG, "Parse user returns NULL");
					return null;
				}
				Log.i("ciudad", user.getCountry());
				node = (GeoNodo) user;
			}
	
			if (type.equalsIgnoreCase("photo")){
				Foto photo = parsePhoto(obj);
				if (photo == null){
					Log.e(TAG, "Parse photo returns NULL");
					return null;
				}
				node = (GeoNodo) photo;
			}
			if (node == null){
				Log.e(TAG,"NODE WAS NULL");
				return null;
			}
			
			node.setAltitude(altitude.floatValue());
			node.setLatitude(latitude);
			node.setLongitude(longitude);
			node.setRadius(radius);
			node.setSince(since);
			node.setId(id);
			node.setPosition_since(position_since);
			node.setUsername(username);
			node.setUser_id(user_id);
			
			
			return node;
			
		} catch (JSONException e) {	
			
			lastCode = 500;
			lastMsg = "Error in json parsed: " + e.getMessage();
			Log.e(TAG, e.toString());
			return null;
		}
	}
	
	
	
	private Foto parsePhoto (JSONObject obj){
		String description = null;
		String name = null;
		String url = null;	
		Integer id = null;
				
		try {
			
			if (obj.has("id"))
				id = obj.getInt("id");
			else
				id = 0;
			
			if (obj.has("name"))
				name = obj.getString("name");
			if (obj.has("description"))
				description = obj.getString("description");	
			
			ExtenalInfo extInfo = null;
			url = null;
			
			if (id==0)
			{
				extInfo = new ExtenalInfo();
				
				if (obj.has("external_info"))
				{
					JSONObject objPosition = obj.getJSONObject("external_info");
					
					if (objPosition.has("info_url"))
						extInfo.setUrlInfo(objPosition.getString("info_url"));
					
					if (objPosition.has("photo_thumb"))
					{
						extInfo.setPhotoThumbUrl (objPosition.getString("photo_thumb"));
						url = extInfo.getPhotoThumbUrl();
					}
					
					if (objPosition.has("photo_url"))
						extInfo.setPhotoNormalUrl (objPosition.getString("photo_url"));
				}
				
			}
			
			else{
				Log.e("LAYER", id.toString());
				Integer layerId = (Integer) getLayerId(id).get(0);
				url = "layer/" + layerId.toString() + "/node/" + id.toString() + "/image/";
			}
			Foto myPhoto = new Foto (id,0.0,0.0,0.0,0.0,name,description,url,null, null, null, 0.0);
			myPhoto.setExternalInfo (extInfo);
			
			return myPhoto;
			
		} catch (JSONException e) {	
			lastCode = 500;
			lastMsg = "Error in json parsed: " + e.getMessage();
			Log.e(TAG, e.toString());
			return null;
		}
	}
	
	
	private Usuario parseUser (JSONObject obj){
		
		String username = "", name = "", lastName ="", status="", status_since="";
		String email ="";
		String birthDay="";
		Integer avatarId = null;
		String avatarUrl = "";
		String country = "";
		Integer postCode = 0;
		try{
			if (obj.has("first_name"))
				name = obj.getString("first_name");	
			
			if (obj.has("last_name"))
				lastName = obj.getString("last_name");

			if (obj.has("username"))
				username = obj.getString("username");

			if (obj.has("status")){
				JSONObject jsonStatus = obj.getJSONObject("status");
				status = jsonStatus.getString("message");
				status_since = jsonStatus.getString("since");
			}

			if (obj.has("email"))
				email = obj.getString("email");
		
			if (obj.has("birthday"))
				birthDay = obj.getString("birthday");

			if (obj.has("avatar"))
			{
				JSONObject jsonPosition = obj.getJSONObject("avatar");
			
				avatarId = jsonPosition.getInt("photo_id");
				avatarUrl = jsonPosition.getString("photo_url");
			}

			if (obj.has("position"))
			{
				JSONObject jsonPosition = obj.getJSONObject("position");
				Log.i("POSITION", jsonPosition.toString());
				if (jsonPosition.has("country"))
					country = jsonPosition.getString("country");
				
				if (jsonPosition.has("post_code"))
					postCode = jsonPosition.getInt("post_code");
				
			}
			
			return new Usuario(null,name,lastName,username,email,status,0.0,0.0,0.0,0.0, 
					null,country,postCode,birthDay,null, avatarId, avatarUrl, status_since, null);
			
		} catch (JSONException e) {	
			lastCode = 500;
			lastMsg = "Error in json parsed: " + e.getMessage();
			Log.e(TAG, e.toString());
			return null;
		}
	}
	
	public ArrayList getLayerId (Integer nodeId){
		Integer id = 0;
		String name = "";
		
		try
		{
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			HttpGet httpGet = new HttpGet(mUrl + "node/" + nodeId.toString() + "/layers/?format=JSON");						
			
			HttpResponse response = httpclient.execute(httpGet);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());
	        
	        Log.e(TAG, str);

	        
	        JSONObject json;
	        
	        ArrayList list = new ArrayList();
	        
	        try {
				json = new JSONObject(str);
				lastCode = json.getInt("code");
								
				if (lastCode != 200)
					return null;
				
				JSONArray array;
				
				array = json.getJSONArray("results");
				
				for (int i = 0; i < array.length(); i++) 
				{ 
					JSONObject layer = array.getJSONObject(i);
					
					if (layer.has("id"))
						id = layer.getInt("id");
					list.add(id);
				}
				return list;
	        } catch (JSONException e) {	
				lastCode = 500;
				lastMsg = "Error in json parsed: " + e.getMessage();
				Log.e(TAG, e.toString());
				return null;
			}

            
		}catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}
	}
	
	public ArrayList<CapaGenerica> getLayerList(){
		
		String layer_type, name, description, since;
		Integer id = 0;
		Double altitude, distance;
		String position_since;
		
		layer_type = name = description = since = position_since = "";
		altitude = distance = 0.0;
		
		Log.e("LGS","getLayerList - 2");
		
		try
		{
			List <NameValuePair> nvps = new ArrayList <NameValuePair>();
			// IMplementacion por defecto del cliente HTTP
			DefaultHttpClient httpclient = new DefaultHttpClient();
			
			// Este metodo redirecciona peticiones del servidor http por defecto
			HttpGet httpGet = null;
			
			if (isLogged()){
				httpGet = new HttpGet(mUrl + "layer/list/?format=JSON&user_layer=true");
			} else {
				httpGet = new HttpGet(mUrl + "layer/list/?format=JSON");
			}
			
			HttpResponse response = httpclient.execute(httpGet);
	
		    HttpEntity entity = response.getEntity(); 
		    
	        String str = convertStreamToString(entity.getContent());
	        
	        Log.e(TAG, str);

	        
	        JSONObject json;
	        
	        ArrayList<CapaGenerica> list = new ArrayList<CapaGenerica>();
	        
	        try {
				json = new JSONObject(str);
				lastCode = json.getInt("code");
								
				if (lastCode != 200)
					return null;
				
				JSONArray array;
				
				array = json.getJSONArray("results");

				Log.e("parseNodes_new: ",String.valueOf(array.length()));
				Log.e("PARSE", array.toString());
				
				for (int i = 2; i < 3; i++) 
				{ 
					Log.e("PARSE", array.getJSONObject(i).toString());
					JSONObject layer = array.getJSONObject(i);
					
					if (layer.has("layer_type"))
						layer_type = layer.getString("layer_type");
					if (layer.has("name"))
						name = layer.getString("name");
					if (layer.has("since"))
						since = layer.getString("since");
					if (layer.has("id"))
						id = layer.getInt("id");
					if (layer.has("description"))
						description = layer.getString("description");
					
					JSONObject position = layer.getJSONObject("position");
					
					if (position.has("since"))
						position_since = position.getString("since");
					if (position.has("distance"))
						distance = position.getDouble("distance");
					if (position.has("altitude"))
						altitude = position.getDouble("altitude");
					
					CapaGenerica mLayer =  new CapaGenerica(id, layer_type, name, description,  since,
							null, null, altitude, distance, position_since  );
					
					list.add(mLayer);
					
				}
				
				return list;
				
			} catch (JSONException e) {	
				lastCode = 500;
				lastMsg = "Error in json parsed: " + e.getMessage();
				Log.e(TAG, e.toString());
				return null;
			}

            
		}catch (IOException e) {
	        Log.e(TAG,e.getMessage());
	        return null;
		}
	}
	
	
	
	public static void allowAllSSL(){
		
		javax.net.ssl.HttpsURLConnection.setDefaultHostnameVerifier(new HostnameVerifier(){

			public boolean verify(String hostname, SSLSession session) {
				// TODO Auto-generated method stub
				return true;
			}
			
		});
		
		javax.net.ssl.SSLContext context = null;
		
		if(trustManagers==null){
			trustManagers = new javax.net.ssl.TrustManager[]{new _FakeX509TrustManager()};
		}
		
		try{
			context = javax.net.ssl.SSLContext.getInstance("TLS");
			context.init(null, trustManagers, new SecureRandom());
			
		}catch(NoSuchAlgorithmException e){
			Log.e("allowAllSSL", e.toString());
		}catch(KeyManagementException e){
			Log.e("allowAllSSL", e.toString());
		}
		
		javax.net.ssl.HttpsURLConnection.setDefaultSSLSocketFactory(context.getSocketFactory());
		
	}
	
	public static class _FakeX509TrustManager implements javax.net.ssl.X509TrustManager{
		
		private static final X509Certificate[] _AcceptedIssuers = new X509Certificate[]{};
		
		public void checkClientTrusted(X509Certificate[] chain, String authType)
				throws CertificateException {
			// TODO Auto-generated method stub
			
		}

		public void checkServerTrusted(X509Certificate[] chain, String authType)
				throws CertificateException {
			// TODO Auto-generated method stub
			
		}
		
		public boolean isClientTrusted(X509Certificate[] chain){
			return true;
		}
		
		public boolean isServerTrusted(X509Certificate[] chain){
			return true;
		}
		
		public X509Certificate[] getAcceptedIssuers() {
			// TODO Auto-generated method stub
			return _AcceptedIssuers;
		}
		
	}
	
}
